Index: trunk/calendar/templates/classic/js/edit_exmail.js
===================================================================
--- trunk/calendar/templates/classic/js/edit_exmail.js	(revision 1515)
+++ trunk/calendar/templates/classic/js/edit_exmail.js	(revision 1587)
@@ -350,5 +350,5 @@
 	switch (chValue){
 		case 'hourAppointment':
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -357,5 +357,6 @@
 					Field[0].parentNode.parentNode.style.display = "none";
 			}
-
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "none";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "none";
@@ -367,5 +368,5 @@
 			break;
 		case 'privateHiddenFields':
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -374,4 +375,6 @@
 					Field[0].parentNode.parentNode.style.display = "";
 			}
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "none";
@@ -383,5 +386,5 @@
 			break;
 		default:
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -390,4 +393,6 @@
 					Field[0].parentNode.parentNode.style.display = "";
 			}
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "";
Index: trunk/calendar/templates/default/js/edit_exmail.js
===================================================================
--- trunk/calendar/templates/default/js/edit_exmail.js	(revision 1500)
+++ trunk/calendar/templates/default/js/edit_exmail.js	(revision 1587)
@@ -350,5 +350,5 @@
 	switch (chValue){
 		case 'hourAppointment':
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -357,5 +357,6 @@
 					Field[0].parentNode.parentNode.style.display = "none";
 			}
-
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "none";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "none";
@@ -367,5 +368,5 @@
 			break;
 		case 'privateHiddenFields':
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -374,4 +375,6 @@
 					Field[0].parentNode.parentNode.style.display = "";
 			}
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "none";
@@ -383,5 +386,5 @@
 			break;
 		default:
-			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval','rpt_label');
+			var names=new Array('title','priority','location','alarmhours','alarmminutes','recur_type','rpt_use_end','recur_interval');
 			for (var i=0; i < names.length; i++)
 			{
@@ -390,4 +393,6 @@
 					Field[0].parentNode.parentNode.style.display = "";
 			}
+			Field = document.getElementById('rpt_label');
+			Field.parentNode.parentNode.style.display = "";
 			Field = document.getElementsByName('participants[]');
 			Field[0].parentNode.parentNode.style.display = "";